<template>
  <div class="reset">
    <div class="title-wrapper d-flex align-items-center">
      {{ $t('auth.change_password.title') }}
    </div>

    <div class="content-wrapper">
      <div class="email-wrapper d-flex align-items-center">
        <div class="input_group_prepend">
          <span class="input-group-text"><i class="iconmo-email"></i></span>
        </div>
        <input class="input-email form-control w-100 input_form" @keyup.enter="reset" v-validate="'required|email'"
               @focus="resetError" v-model="email" type="email" :placeholder="$t('auth.placeholder.email')" name="email">
        <span class="invalid-feedback" v-if="errors.has('email') && hasError">{{ errors.first('email') }}</span>
      </div>

      <div class="submit-btn text-center">
        <button type="button" @click="reset" class="button-primary">{{ $t('auth.btn.upper_submit') }}</button>
      </div>
    </div>
  </div>
</template>

<script>
  import rf from '../../../common/requests/RequestFactory';
  import CheckAuthMixin from './CheckAuthMixin';

  export default {
    data () {
      return {
        email: '',
        hasError: false,
      };
    },
    mixins: [CheckAuthMixin],
    methods: {
      resetError () {
        if (this.hasError) {
          this.errors.clear();
          this.hasError = false;
        }
      },
      reset () {
        this.$validator.validateAll()
          .then(() => {
            if (this.errors.any()) {
              this.hasError = true;
              return;
            }
            const params = {
              email: this.email,
            };
            rf.getRequest('UserRequest').resetPassword(params)
              .then((res) => {
                this.$router.push('/login');
                this.$toasted.show(this.$t('auth.reset_password.send_link_message'), {
                  theme: 'bubble',
                  position: 'top-right',
                  duration: 2000
                });
              })
              .catch((error) => {
                this.hasError = true;
                const errors = error.errors;
                this.errors.clear();
                Object.keys(errors).forEach((key) => {
                  this.errors.add({
                    field: key,
                    msg: errors[key][0]
                  });
                });
              });
          });
      },
    },
  }
</script>


<style lang="scss" scoped>
  @import "../../../../sass/mobile/typoVariables";

  .reset {
    height: calc(100vh - 168rem);
    background: $bg_primary;
    font-size: $medium;
    .title-wrapper {
      padding-left: 13rem;
      background-color: #21335b;
      height: 55rem;
      line-height: initial;
      font-size: 18rem;
      color: $white;
    }
    .content-wrapper {
      padding: 30rem $tiny 0 $tiny;
      input:-webkit-autofill,
      input:-webkit-autofill:hover,
      input:-webkit-autofill:focus textarea:-webkit-autofill,
      select:-webkit-autofill,
      select:-webkit-autofill:hover,
      select:-webkit-autofill:focus {
        border: none;
        -webkit-text-fill-color: #000;
        -webkit-box-shadow: 0 0 0px 1000px $white inset;
      }
      .invalid-feedback {
        font-size: 13rem;
        color: red;
        display: block;
        padding-left: $tiny;
      }
      .email-wrapper {
        height: 40rem;
        border-radius: 74rem;
        background-color: $white;
        position: relative;
        .icon-user:before {
          font-size: 15rem;
          padding: 0 5rem 0 10rem;
          color: #d8d8d8;
        }
        .input-email {
          @extend .Medium-14;
          border: 1px solid transparent;
          color: #000;
          &::placeholder {
            color: #cacaca;
          }
        }
      }
      .submit-btn {
        margin-top: 25rem;
        button {
          @extend .button-12;
          background: transparent;
          width: 295px;
          height: 32rem;
          border-radius: 30rem !important;
          border: solid 1rem #fa7300;
          color: #fa7300;
          font-weight: bold;
          letter-spacing: 0.5rem;
        }
      }
    }
  }

  .button-primary {
    width: 122rem !important;
    height: 35rem !important;
    border-radius: 30rem !important;
    background-color: #fa7300 !important;

    border: none !important;
    outline: none !important;
    color: white !important;
    cursor: pointer !important;
    letter-spacing: 1rem !important;
    font-weight: bold !important;
  }

  .invalid-feedback {
    color: red;
    position: absolute;
    text-align: left;
    bottom: -20rem;
    font-size: 10rem;
    left: 5rem;
  }

  .input_form {
    border: 1px solid transparent;
    color: #000;
    padding-left: 40rem;
    height: 100%;
    border-radius: 74rem;
    outline: none;
    &:focus {
      box-shadow: 0 0 20px 0 rgba(0, 0, 0, 0.15);
    }
  }
  .input_group_prepend {
    width: 19px;
    display: inline-block;
    margin-left: 16rem;
    line-height: 45rem;
    font-size: 15.5rem;
    position: absolute;
    color: #B0B0B0;
  }
</style>

